﻿using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;

namespace UserControlWebPart
{
    [Guid("1d39cc5c-9021-4baa-96ef-eaad9077475c")]
    public class UserControlWebPart : System.Web.UI.WebControls.WebParts.WebPart
    {
        private void EnsureUpdatePanelFixups()
        {
            if (this.Page.Form != null)
            {
                string formOnSubmitAtt = this.Page.Form.Attributes["onsubmit"];
                if (formOnSubmitAtt == "return _spFormOnSubmitWrapper();")
                {
                    this.Page.Form.Attributes["onsubmit"] = "_spFormOnSubmitWrapper();";
                }
            }

            ScriptManager.RegisterStartupScript(this.Page, typeof(Page), "UpdatePanelFixup", "_spOriginalFormAction = document.forms[0].action; _spSuppressFormOnSubmitWrapper=true;", true);
        }

        protected override void Render(HtmlTextWriter writer)
        {
            EnsureUpdatePanelFixups();
            base.Render(writer);
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            EnsureChildControls();
        }
        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            Control control = Page.LoadControl("~/UserControls/WebUserControl.ascx");
            if (control != null) 
            {
                this.Controls.Add(control);
            }
        }
    }
}
